
                        dc.l    $01000000
                        dc.l    __start

                        cnop    0, $70
                        dc.l    _line_int

                        cnop    0, $78
                        dc.l    _frame_int

                        ; Cartridge header
                        cnop    0, $100
                        dc.b    'SEGA GENESIS    '
                        dc.b    '(C)SEGA 2000.DEC'
                        dc.b    '                '
                        dc.b    '                '
                        dc.b    '                '
                        dc.b    '                '
                        dc.b    '                '
                        dc.b    '                '
                        dc.b    'GM MK-0000 -00'
                        dc.w    $0000                   ; checksum
                        dc.b    'J               '      ; peripherals
                        dc.l    $00000000, $003FFFFF    ; rom range
                        dc.l    $00E00000, $00FFFFFF    ; ram range
                        dc.b    '                '
                        dc.b    '                '
                        dc.b    '                '
                        dc.b    '                '
                        dc.b    'JUE             '      ; country code

                        cnop    0, $200
__start:
                        ; Disable interrupts
                        move.w  #$2700, sr

                        ; Do security check
                        move.b  $A10001, d0
                        andi.b  #$0F, d0
                        beq.s   @not_v1
                        move.l  #'SEGA', $A14000
        @not_v1:

                        ; Clear RAM
                        lea     $FF0000, a1
                        move.l  #$3FFF, d0
        @clear_ram:     move.l  #0, (a1)+
                        dbra    d0, @clear_ram

                        ; Stop Z80 reset and get bus
                        move.w  #$0100, $A11200
                        move.w  #$0100, $A11100
        @get_bus:       btst    #8, $A11100
                        bne.s   @get_bus

                        ; Clear address and data registers
                        movem.l $FF0000, d0-d7/a0-a6

                        jmp     _start
